#ifdef __cplusplus
extern "C" {
void abort(void);
#endif
void main(void);
#ifdef __cplusplus
}
#endif

//CN[ht@C
#include<36064s.h>
#include <stdlib.h>
#include <string.h>
#include <stdio.h>
#include <math.h>
#include "vs-bb020.h"
#include "memmap.h"

//O[oϐ

BYTE mode;						//샂[hi0FLu[VA1FJnj
const BYTE MainCycle = 120;		//C[vg
unsigned int main_counter = 0;	//X^[gpJE^[
extern unsigned char memmap[MEMMAP_SIZE];

double out_L,out_R;					//o͒l@Z

//|pp[^
volatile double angle;		//px
volatile double dangle;		//px
volatile double d2angle;	//px
volatile double z_L;		//ړ
volatile double dz_L;		//ړx
volatile double z_R;		//ړ
volatile double dz_R;		//ړx

//p[^Zop
volatile double old_dangle;	//pxi1TCNÓApxZopj
volatile double old_z_L;	//ړi1TCNÓj
volatile double old_z_R;	//ړi1TCNÓj

volatile int GyBuff[10];	//WCZTpobt@
volatile double GYCenter;	//WC_iItZbgj

//Oړpϐ
int fwvale_L,fwvale_R;	//Oړ
int amari_L,amari_R;	//Z܂p
extern int enc_L,enc_R;	//GR[_Zl

unsigned int vec_Bat[10];	//drdpobt@iVbat/2i[j

//]|op
int MaxPowerCntCW = 0;		//SJԑpivj
int MaxPowerCntCCW = 0;		//SJԑpivj


//֐
extern void main(void);


//WCZT̒lobt@Ɋi[
void setAdBuf(){
	int i;
	for(i = 9 ; i>0 ; i--){
		GyBuff[i] = GyBuff[i-1];
	}
	GyBuff[0] = GetGyro();
}

//WCZT̕ϒl擾i_ƂlŁj
int getGyAve(){
	int i,max = -5000 ,min = 5000;
	double temp = 0;
	
	for(i=0 ;i<8;i++){
		temp+=(double)GyBuff[i];
		if(GyBuff[i] > max)
			max = GyBuff[i];
		if(GyBuff[i] < min)
			min = GyBuff[i];
	}
	temp -=(max + min);		//őAŏ̒l͏i}ȃmCY̏œ艻j
	
	return (int)(temp/6.0 - GYCenter);
}

//p[^̃NA
void ClearValue(){
	ClearZ();
	main_counter = 0;
	angle = 0.0;
	dangle = 0.0;
	d2angle = 0.0;
	old_dangle = 0.0;
	z_L = 0.0;
	old_z_L = 0.0;
	z_R = 0.0;
	old_z_R = 0.0;
	dangle = 0.0;
	dz_L = 0.0;
	dz_R = 0.0;
	fwvale_R = 0;
	fwvale_L = 0;
	amari_L = 0;
	amari_R = 0;
	ClearZ();	
}

//WCZT̃Lu[Vp֐
void calibration(){
	int n;
	double tempValue = 0.0;
	
	BuzzerStop();
	Sync();
	
	for(n =0;n<100;n++){
		tempValue += (double)GetGyro();
		Sync();
	}
	GYCenter = (tempValue/100.0);
	tempValue = 0.0;
	memset(GyBuff , GYCenter,sizeof(GyBuff));
	
	//Ot\ONȂVAʐM
	if(memmap[RUN_MODE]&0x80){
		if(memmap[SCI_READ] == 0)
			SCI3.SCR3.BIT.RIE = 1;
		else
			SCI3_2.SCR3.BIT.RIE = 1;
	}
	else{		
		SCI3.SCR3.BIT.RIE = 0;
		SCI3_2.SCR3.BIT.RIE = 0;
		SCI3_2.SCR3.BIT.TEIE = 0;
		SCI3_2.SCR3.BIT.TIE = 0;			//TDRE荞ݕs
	}
	
	ClearValue();	

	mode = MODE_RUN;
}

//E[^̈ړʂݒipbhACg[XȂǁAړۂɎgpj
void setMtrSpeed(int L , int R){
	#define SPD_BUF 4 
	static int L_buff[SPD_BUF],R_buff[SPD_BUF];
	BYTE i;
	
	for(i = SPD_BUF - 1 ; i > 0 ; i--){
		L_buff[i] = L_buff[i - 1];
		R_buff[i] = R_buff[i - 1];
	}
	
	L_buff[0] = L;
	R_buff[0] = R;
	
	fwvale_R = -(L_buff[0] + (int)(0.0*(double)(L_buff[0] - L_buff[1])));
	fwvale_L = -(R_buff[0] + (int)(0.0*(double)(R_buff[0] - R_buff[1])));
}

//샂[h擾
BYTE getMode(){
	return mode;
}
void weels_main(void)
{
//ϐ
	int i=0;					//ėp
	UINT mtr[2] = {0,0};	//[^o	
	unsigned int *vecGain;	
	
 	vecGain = (unsigned int*)&memmap[GAIN_MAP];		//QCpz̃AhXݒ
		
	mode = MODE_STOP;				//[hXgbvɐݒ
	Init((BYTE)MainCycle);			//H8̏	
	InitSci3(CBR_115200,even,1);	//VȀi{[[g115200ApeBAXgbvrbg1bit)
	
	LED(1);	
	Mtr_Run_BB(0,0);		//[^~	
	Rd_MEMMAP();			//ݒǍ	
	BuzzerSet(0x80,0x80);	//uU[̐ݒ

	//N҂
	for(i=0;i<10;i++)
		Sync();
	
	//WCZTpobt@𖄂߂
	for(i = 0 ; i < 10 ; i++)
		setAdBuf();
		
//C[v
	while(1){
		if((memmap[RUN_MODE]&0x80) || mode == MODE_STOP)
			CheckSci();		//VA`FbN
			
		updatePAD();	//PADf[^XV
		
		//WCZTl擾~7
		setAdBuf();	
		setAdBuf();
		Sync();
		setAdBuf();
		setAdBuf();
		setAdBuf();
		setAdBuf();
		setAdBuf();
		main_counter ++;
		
	//ʐMALu[V[h
		if(mode == MODE_STOP){  		
			main();			
		}
		
	//s[h
		else if(mode == MODE_RUN){
			if(getSW()){		//쒆XCb`ꂽ
				ClearValue();	//p[^ϐNAꎞ~
			}
			else if(main_counter > MainCycle*3){	//3bɃC֐̓JniMainCyclegȂ̂...j
				main();		
			}
			
		//ZTlϊp萔
			#define conv_gy -0.120248368	//(-3.3/(4096.0*0.0067))
			#define conv_enc 0.9		//360.0/(5*4*40/2);
		
		//{̈ړʉZ
			enc_L += (fwvale_L + amari_L)/10;
			enc_R += (fwvale_R + amari_R)/10;
		
			amari_L = (fwvale_L + amari_L)%10;
			amari_R = (fwvale_R + amari_R)%10;
				
	//p[^̎Zo
			old_dangle = dangle;
		//px̎擾					
			dangle = (double)getGyAve()*conv_gy;	// 6.7mv/deg/sec, 3.3v = 4096	
		//px̎Zo
			angle += dangle;
		//px̎Zo	
			d2angle = dangle - old_dangle;
		
		//ԗֈʒu̎擾
			z_R = (double)enc_R*conv_enc;
			z_L = (double)enc_L*conv_enc;
		
		//dd̎擾	
			for(i = 9;i>0;i--){
				vec_Bat[i] = vec_Bat[i-1];
			}
			vec_Bat[0] = AdRead(7);
		
		//x̎Zo
			dz_L = (z_L - old_z_L)*MainCycle;
			dz_R = (z_R - old_z_R)*MainCycle;
			old_z_L = z_L;
			old_z_R = z_R;
		
		//|
		{
			double ENC_GAIN = (double)vecGain[GAIN_EN_P]/1000.0;
			double dENC_GAIN = (double)vecGain[GAIN_EN_D]/1000.0;
			double ANGLE_GAIN = (double)vecGain[GAIN_GY_I]/1000.0;
			double dANGLE_GAIN = (double)vecGain[GAIN_GY_P]/1000.0;
			double d2ANGLE_GAIN = (double)vecGain[GAIN_GY_D]/1000.0;
			
		//dd̃tB[hobN
			double batvalue = 0.0;
			int bat_min = 1023,bat_max = 0;
			
			for(i = 0;i<10;i++){
				batvalue += vec_Bat[i];
				if(bat_min > vec_Bat[i])
					bat_min = vec_Bat[i];
				if(bat_max < vec_Bat[i])
					bat_max = vec_Bat[i];
			}
			
			batvalue -= (bat_max + bat_min);
 			batvalue = (batvalue / (1024.0 * 8.0) ) *  3.3 ;
			batvalue = (1.1 - batvalue)*2.5;
			
			if(batvalue > 0.0)
				batvalue = 0.0;
			else if(batvalue < -0.5)
				batvalue = -0.5;
			
		//[^o͂̎Zo
			out_L = ENC_GAIN*z_L 		//P ړ@iGR[_j
					+ dENC_GAIN*dz_L 	//D@x@iGR[_j
					
					- 1.0 * ENC_GAIN * (z_L - z_R)
					- 0.5 * dENC_GAIN * (dz_L - dz_R)
				
				+ ANGLE_GAIN * angle  	 //P@pxiWCj
				+ dANGLE_GAIN * dangle 	//D@pxiWCj
				+ d2ANGLE_GAIN * d2angle
			;
			
			out_R = ENC_GAIN*z_R 		//P ړ@iGR[_j
				+ dENC_GAIN*dz_R 	//D@x@iGR[_j

				-1.0 * ENC_GAIN * (z_R - z_L)
				-0.5 * dENC_GAIN * (dz_R - dz_L)
								
				+ ANGLE_GAIN * angle  	//P@pxiWCj
				+ dANGLE_GAIN * dangle 	//D@pxiWCj
				+ d2ANGLE_GAIN * d2angle
			;
			
			out_L *= (1.0+batvalue);
			out_R *= (1.0+batvalue);
		}
		
		//e[^o͂̃I[o[t[`FbNAo͐ݒ
			if(out_L>=0.0){
				long OutPutTemp = 0;
				OutPutTemp = (long)(out_L * 256);
				if(OutPutTemp>0x7FFF)
					OutPutTemp = 0x7FFF;
				mtr[0] = (UINT)(0x10000 - OutPutTemp);
			}
			else{
				long OutPutTemp = 0;
				OutPutTemp = -(long)(out_L * 256);
				if(OutPutTemp > 0x7FFF)
					OutPutTemp = 0x7FFF;
				mtr[0] = (UINT)OutPutTemp;
			}
			if(out_R>=0.0){
				long OutPutTemp = 0;
				OutPutTemp = (long)(out_R * 256);
				if(OutPutTemp>0x7FFF)
					OutPutTemp = 0x7FFF;
				mtr[1] = (UINT)(0x10000 - OutPutTemp);
			}
			else{
				long OutPutTemp = 0;
				OutPutTemp = -(long)(out_R * 256);
				if(OutPutTemp > 0x7FFF)
					OutPutTemp = 0x7FFF;
				mtr[1] = (UINT)OutPutTemp;
			}
		//]|oiō1bj
	
			if(mtr[1] == 0x7FFF)
				MaxPowerCntCW++;
			else 
				MaxPowerCntCW = 0;
			if(mtr[1] == 0x8001)
				MaxPowerCntCCW++;
			else 
				MaxPowerCntCCW = 0;
				
		//]|̒~
			if(MaxPowerCntCW > 1*MainCycle || MaxPowerCntCCW > 1*MainCycle ){
				Mtr_Run_BB(0,0);
				Wait(1000);
				mode = MODE_STOP;
							
				ClearValue();
			}
		//[^֏o
			else 
				Mtr_Run_BB(mtr[0],mtr[1]);
		}
	}
}

//OpVAo
void send_data(char str){
	char i,j;
	char txt[48];
	char txt_size;
	txt_size = 0;
	if(str == 'g'){
		txt[txt_size] = 'g';
			txt_size++;
		
		for(j = 0;j < 3;j++){
			char* f_ptr;
			if(j == 0)
				f_ptr = (char*)&d2angle;
			else if(j == 1)
				f_ptr = (char*)&dangle;
			else
				f_ptr = (char*)&angle;
			
			txt[txt_size] = ':';
			txt_size++;
			for(i = 0;i<4;i++){
				txt[txt_size] = f_ptr[i];
				txt_size++;
			}
		}
	}
	else if(str == 'l'){
		txt[txt_size] = 'l';
			txt_size++;
		
		{
			char* f_ptr;
			f_ptr = (char*)&z_L;
			
			txt[txt_size] = ':';
			txt_size++;
			for(i = 0;i<4;i++){
				txt[txt_size] = f_ptr[i];
				txt_size++;
			}

			f_ptr = (char*)&dz_L;
			txt[txt_size] = ':';
			txt_size++;
			for(i = 0;i<4;i++){
				txt[txt_size] = f_ptr[i];
				txt_size++;
			}
		}
	}
	else if(str == 'm'){
		txt[txt_size] = 'm';
		txt_size++;
		txt[txt_size] = ':';
		txt_size++;
		
		{
			char* f_ptr;
			f_ptr = (char*)&z_R;
			
			for(i = 0;i<4;i++){
				txt[txt_size] = f_ptr[i];
				txt_size++;
			}

			txt[txt_size] = ':';
			txt_size++;
		
			f_ptr = (char*)&dz_R;
			for(i = 0;i<4;i++){
				txt[txt_size] = f_ptr[i];
				txt_size++;
			}
		}
	}

	else if(str == 'o'){
		txt[txt_size] = 'o';
		txt_size++;
		txt[txt_size] = ':';
		txt_size++;
		
		{
			char* f_ptr;
			f_ptr = (char*)&out_L;
			
			for(i = 0;i<4;i++){
				txt[txt_size] = f_ptr[i];
				txt_size++;
			}

			txt[txt_size] = ':';
			txt_size++;
		
			f_ptr = (char*)&out_R;
			for(i = 0;i<4;i++){
				txt[txt_size] = f_ptr[i];
				txt_size++;
			}
		}
	}
	if(txt_size > 0){
		txt[txt_size] = '\r';
		txt_size++;
		txt[txt_size] = '\n';
		txt_size++;
		txt[txt_size] = '\0';
		SciStrTx(txt,txt_size);
	}
}



#ifdef __cplusplus
void abort(void)
{
	
}
#endif
